	/*
	This is the script source for the main mxml document called from script source 
	(thus why it has no "packaging")
	*/
	
	/*
	All graphics, design, and additional programming by: Anthony Scavarelli - http://blog.anthony-scavarelli.com/
	Special thanks to:
	- Fuel Industries for the time to build this. http://www.fuelindustries.com/
	- The Papervision team for their wonderful Papervision classes
	- The Kingnare css and swf control styles by Jin Xin here: http://www.scalenine.com/themes/kingnare/Kingnare.html#
	- Pablo Bandin (http://pablobandin.wordpress.com), for the basis of an animation control class
	- and the many Papervision and Flex resources on teh interwebs for help with the set-up and many problems encountered building this app.
	
	This application is available for any use, or modeification. I would appreciate any feedback or comments on how you have been able to use it or modify it at it’s original source:
	*/
	
	//the slider controls
	import com.core.ColladaViewer;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.OutputProgressEvent;
	import flash.filesystem.*;
	import flash.net.FileFilter;
	
	[Embed(
	source="style/assets/graphics/buttons.swf",
	symbol="Preloader"
	)]
	[Bindable]
    public var _preloader:Class;

	protected var modelOpen:File = new File();
	protected var textureOpen:File = new File();
	protected var txtFilter:FileFilter = new FileFilter("Text", "*.dae;*.DAE;"); //opening models filters
	protected var imageFilter:FileFilter = new FileFilter("Texture", "*.jpg;*.png;"); //texture filters
	
	protected var _mFileName:String; //model filePath
	protected var _mTextureName:String; //texture filePath
	
	protected var _modelSelected:Boolean = false;
	protected var _textureSelected:Boolean = false;
	protected var _playButton:Boolean = true; //to keep track of switch from play to pause
	
	//mouseVars
 	protected var _mouseDown:Boolean = false;
	protected var _mouseOver:Boolean = false;
	protected var _mmDown:Boolean = false;
	protected var _mmCountXOld:Number = 0;
	protected var _mmCountYOld:Number = 0;
	protected var _mmCountXNew:Number = 0;
	protected var _mmCountYNew:Number = 0;
	protected var _mmDeltaX:Number = 0;
	protected var _mmDeltaY:Number = 0; 
	
	//second xml window
	public var _xmlWin:XMLWin;
	public var _secondaryWinOpen:Boolean = false;
	public var _daeData:File; //holds dae data for viewing/saving
	public var _daeDataStream:FileStream = new FileStream();
	protected var _modelAnimated:Boolean = false;
	
	
	/*********************** initialization *************************/
	protected function init():void {
		ModelColour.selectedColor = CollView.modColour;
		WireFrameColour.selectedColor = CollView.wfColour;
		
		//setting up listeners for closing and minimizing
		minCloseApp.addEventListener(MinClose.MIN_PRESSED, minApp);
		minCloseApp.addEventListener(MinClose.CLOSE_PRESSED, closeApp);
	}
	/*********************** end initialization *************************/
	
	/*****************************************************************/
	/*********************** event functions *************************/
	/*****************************************************************/
	protected function closeApp(e:Event):void {
		minCloseApp.removeEventListener(MinClose.CLOSE_PRESSED, closeApp);
		NativeApplication.nativeApplication.exit();
	}
	
	protected function closeSecondWin(e:Event):void {
		if (_xmlWin != null) {
			_xmlWin.close();
			_secondaryWinOpen = false;
		}
	}
	
	//for dragging window
	protected function dragWindow(e:MouseEvent):void {
		stage.nativeWindow.startMove();
	}
	
	protected function fileReadHandler(e:Event):void {
		_daeDataStream.removeEventListener(Event.COMPLETE, fileReadHandler);
		
		trace("finished reading file");
		var str:String = _daeDataStream.readUTFBytes(_daeDataStream.bytesAvailable);
		var lineEndPattern:RegExp = new RegExp(File.lineEnding, "g");
		str = str.replace(lineEndPattern, "\n");
		_xmlWin.daeData.text = str;
		_daeDataStream.close();
		
		_xmlWin.reading = false;
	}
	
	protected function fileWriteHandler(e:OutputProgressEvent):void {
		 _daeDataStream.removeEventListener(OutputProgressEvent.OUTPUT_PROGRESS, fileWriteHandler);
		 
	 	trace("finished writing");
	 	_daeDataStream.close();
	 	loadModel();
	 	
	 	_xmlWin.writing = false;
	}
	
	protected function getStats():void {
		
		Triangles.text = CollView.numTriangles.toString();
		Vertices.text = CollView.numVertices.toString();
		Num3DObjects.text = CollView.numVisSceneObjects.toString();
		ScaleDiff.text = (round(((CollView.currScale * 100)/(CollView.AXIS_LENGTH)),3)).toString();
	}
	
	protected function initLoadData(e:Event):void {
		_xmlWin.removeEventListener(XMLWin.CREATION_DONE, initLoadData);
		
		trace("loading");
		
		loadDaeData();
	}
	
	 protected function interactiveMove(e:MouseEvent):void {
 	 	//viewport camera rotations
		 if (_mouseOver && _mouseDown) {
		 	
		 	//if alt is pressed then can "track" or "pan" in case user has only one mouse button
		 	if (CollView.altDown) {
		 		_mmCountXNew = mouseY;
				_mmCountYNew = mouseX;
			
				_mmDeltaY = _mmCountXNew - _mmCountXOld;
				_mmDeltaX = _mmCountYNew - _mmCountYOld;
		 		
		 		CollView.moveCamera(_mmDeltaX/2, _mmDeltaY/2); //move camera
		 	} else {
		 		_mmCountXNew = mouseY;
				_mmCountYNew = mouseX;
				
				_mmDeltaX = _mmCountXOld - _mmCountXNew;
				_mmDeltaY = _mmCountYOld - _mmCountYNew;
		 		
		 		interactiveRotMod(_mmDeltaX, _mmDeltaY); //moving camera "orbit around model"
		 	}
		
		} else if (_mouseOver && _mmDown) {
		 //viewport camera movement x-y tracking
		 	
			_mmCountXNew = mouseY;
			_mmCountYNew = mouseX;
		
			 _mmDeltaY = _mmCountXNew - _mmCountXOld;
			_mmDeltaX = _mmCountYNew - _mmCountYOld;
			
			CollView.moveCamera(_mmDeltaX/2, _mmDeltaY/2); //move camera
		} 
	}
	
	protected function minApp(e:Event):void {
		stage.nativeWindow.minimize();
	}
	
	//middle mouse functions
	protected function mmDown(e:MouseEvent):void {
		EmptyBox.removeEventListener(MouseEvent.MIDDLE_MOUSE_DOWN, mmDown);
		EmptyBox.addEventListener(MouseEvent.MIDDLE_MOUSE_UP, mmUp);
		
		_mmCountXOld = mouseY;
		_mmCountYOld = mouseX;
		
		_mmDown = true;
		
		CollView.camPanning = true;
	}
	
	protected function mmUp(e:MouseEvent):void {
		EmptyBox.addEventListener(MouseEvent.MIDDLE_MOUSE_DOWN, mmDown);
		EmptyBox.removeEventListener(MouseEvent.MIDDLE_MOUSE_UP, mmUp);
		
		_mmDown = false;
		CollView.camPanning = false;
	}
	
	protected function modelSelected(event:Event):void {
	 	var _absPath:String = File(event.target).url;
	 	
	 	LMText.text = _absPath;
	 	_modelSelected = true;
	 }
	
	protected function mouseDown(e:MouseEvent):void {
		EmptyBox.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
		stage.addEventListener(MouseEvent.MOUSE_UP, mouseUp);
		
		_mouseDown = true;
		
		_mmCountXOld = mouseY;
		_mmCountYOld = mouseX;
		
		if (CollView.altDown) {
			CollView.camPanning = true;
		} else {
			CollView.camRotating = true;
		}
	}
	
	protected function mouseOutBox(e:MouseEvent):void {
		EmptyBox.addEventListener(MouseEvent.MOUSE_OVER, mouseOverBox);
		EmptyBox.removeEventListener(MouseEvent.MOUSE_OUT, mouseOutBox);
		
		_mouseOver = false;
	} 
	
	protected function mouseOverBox(e:MouseEvent):void {
		EmptyBox.removeEventListener(MouseEvent.MOUSE_OVER, mouseOverBox);
		EmptyBox.addEventListener(MouseEvent.MOUSE_OUT, mouseOutBox);
		EmptyBox.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
		
		_mouseOver = true
	}
	
	protected function mouseUp(e:MouseEvent):void {
		EmptyBox.addEventListener(MouseEvent.MOUSE_DOWN, mouseDown);
		stage.removeEventListener(MouseEvent.MOUSE_UP, mouseUp);
		
		_mouseDown = false;
		CollView.camRotating = false;
		
		CollView.camPanning = false;
		CollView.camRotating = false;
	}
	
	protected function mouseZoom(e:MouseEvent):void {
		CollView.cameraZoom(e.delta * 5);
		CollView.camZooming = true;
	}
	
	protected function reloadModel(e:Event):void {
		if (_xmlWin != null) {
			loadDaeData();
		}
	}
	
	protected function saveEdits(e:Event):void {
		if (!CollView.animLoading) {
			_xmlWin.writing = true;
			
			CollView.releaseModel(); //remove references to model (will reload after write)
			
			_daeData = new File(CollView.modelDir);
		    _daeDataStream = new FileStream();
			_daeDataStream.openAsync(_daeData, FileMode.WRITE);
			_daeDataStream.writeUTFBytes(_xmlWin.daeData.text);
			_daeDataStream.addEventListener(OutputProgressEvent.OUTPUT_PROGRESS, fileWriteHandler);
		}
	}
	
	protected function setTimeLine(e:Event):void {
		//set appropriate animation timeline frames
		AniSlide.maximum = CollView.totalFrames;
	}
	
	protected function textureSelected(event:Event):void {
	 	var _absPath:String = File(event.target).url;
	 	
	 	LTText.text = _absPath;
	 	_textureSelected = true;
	 }
	
	protected function updateAniSlider(e:Event):void {
		AniSlide.value = CollView.currentFrame;
	}
	/****************************************************************/
	/*********************** end event functions ********************/
	/****************************************************************/
	
	/****************************************************************/
	/*********************** methods ********************************/
	/****************************************************************/
	 protected function animationCheck(e:Event):void {
	 	if (CollView.modelAnimated) {
	 		CollView.addEventListener(ColladaViewer.ANIM_COMP, animationComplete);
	 		_modelAnimated = true;
	 	} else {
	 		PreloadAnim.visible=false; //then hide preloader
	 		PreloadText.visible=false;
	 		
	 		getStats();
	 	}
	 }
	 
	 protected function animationComplete(e:Event):void {
	 	//enable slider and buttons
 		AnimLabel.text = "Animation Controls";
 		AniSlide.enabled = true;
 		Play.enabled = true;
 		Stop.enabled = true;
 		FrameBack.enabled = true;
 		FrameForward.enabled = true;
	 	
	 	PreloadAnim.visible=false; //then hide preloader
	 	PreloadText.visible=false;
	 	
	 	
	 	getStats();
	 	//animation is complete
	 	/* if (_xmlWin != null) {
	 		_xmlWin.animComplete = true;
	 	} */
	 }
	 
	 protected function animationScrub():void {
	 	CollView.scrubFrame = AniSlide.value;
	}
	
	protected function automaticTexture():void {
		CollView.autoTexture = !CollView.autoTexture;
	}
	
	 protected function axisVisSwitch():void {
	 	CollView.invisAxis = !CollView.invisAxis;
	 }
	
	protected function browseModel():void {
		try {
		    modelOpen.browseForOpen("Open", [txtFilter]);
		    modelOpen.addEventListener(Event.SELECT, modelSelected);
		}
		catch (error:Error) {
		    trace("Failed:", error.message);
		}
	 }
	 
	 protected function browseTexture():void {
	 	try {
		    textureOpen.browseForOpen("Open", [imageFilter]);
		    textureOpen.addEventListener(Event.SELECT, textureSelected);
		}
		catch (error:Error) {
		    trace("Failed:", error.message);
		}
	 }
	
	protected function colourVisSwitch():void {
	 	CollView.invisColor = !CollView.invisColor;
	 }
	
	//when a window is closed it is set to be released from memory,
	//so if closed I must "reopen" by creating a new window
	protected function createSecondaryWin():void {
		_xmlWin = new XMLWin(); //my xml dae window
		_xmlWin.isAnim = _modelAnimated;
		_xmlWin.title = "DAE XML data";
        _xmlWin.maximizable=false;
        _xmlWin.minimizable = true;
        _xmlWin.resizable = true;
		_xmlWin.visible = true;
		
		_xmlWin.addEventListener(XMLWin.CLOSED, closeSecondWin);
	}
	
	protected function deltaBGColour():void {
	 	//@TODO: add background colour changer
	 }
	
	protected function deltaModColour():void {
	 	CollView.modColour = ModelColour.selectedColor;
	 }
	
	 protected function deltaRotX():void {
	 	CollView.modRotX = XRotSlide.value;
	 	RotationX.text = round(CollView.modRotX,3).toString();
	 }
	 
	 protected function deltaRotY():void {
	 	CollView.modRotY = YRotSlide.value;
	 	RotationY.text = round(CollView.modRotY,3).toString();
	 }
	 
	 protected function deltaScale():void {
	 	CollView.currScale = ScaleSlide.value;
	 	ScaleSlideCoarse.value = ScaleSlide.value;
	 	Scale.text = round(CollView.currScale,3).toString();
	 	ScaleDiff.text = (round(((CollView.currScale * 100)/(CollView.AXIS_LENGTH)),3)).toString();
	 }
	 
	 protected function deltaScaleCoarse():void {
	 	CollView.currScale = ScaleSlideCoarse.value;
	 	
	 	if (ScaleSlideCoarse.value <= 10) {
	 		ScaleSlide.value = ScaleSlideCoarse.value;
	 	} else {
	 		ScaleSlide.value = ScaleSlide.maximum;
	 	}
	 	
	 	Scale.text = round(CollView.currScale,3).toString();
	 	ScaleDiff.text = (round(((CollView.currScale * 100)/(CollView.AXIS_LENGTH)),3)).toString();
	 }
	 
	 protected function deltaWFColour():void {
	 	CollView.wfColour = WireFrameColour.selectedColor;
	 }
	 
	 protected function deltaWFThickness():void {
	 	CollView.WfThickness = WThickness.value;
	 }
	
	protected function frameBack():void {
		CollView.thisFrame = CollView.currentFrame - 1;
		//CollView.pauseAnim();
	}
	
	protected function frameForward():void {
		CollView.thisFrame = CollView.currentFrame + 1;
	}
	
	protected function interactiveRotMod(__deltaX:Number, __deltaY:Number):void {
		CollView.cameraPitch((__deltaX * 0.04)%360);
		CollView.cameraYaw((__deltaY*0.04)%360);
	}
	
	protected function loadDaeData():void {
		_xmlWin.reading = true;

		if (CollView.modelDir == "") {
			readIOErrorHandler();
		} else {
			
			_daeData = new File(CollView.modelDir); //@TODO: need to better checks for if "url" is valid
			
			_daeDataStream = new FileStream();
			_daeDataStream.openAsync(_daeData, FileMode.READ);
			_daeDataStream.addEventListener(Event.COMPLETE, fileReadHandler);
			_daeDataStream.addEventListener(IOErrorEvent.IO_ERROR, readIOErrorHandler);
			
			_xmlWin.addEventListener(XMLWin.SAVE_EDITS, saveEdits);
			_xmlWin.addEventListener(XMLWin.RELOAD_MODEL, reloadModel);
		}
	}
	
	//button controls
	 protected function loadModel():void {
	 	
	 	resetStats(); //setting all "stats" to zero
	 	
	 	if (_modelSelected) {
	 		
		 		if (!CollView.animLoading) {
		 		
			 		this.addEventListener(ColladaViewer.LOAD_ERROR, resetLoad); //to check for any load errors
			 		
			 		PreloadAnim.visible=true; //show preloader
			 		PreloadText.visible=true;
			 		
			 		//disable slider and buttons (will be enabled if animated)
			 		AniSlide.enabled = false;
			 		AniSlide.maximum = 100; //back to default
			 		Play.enabled = false;
			 		Stop.enabled = false;
			 		FrameBack.enabled = false;
			 		FrameForward.enabled = false;
			 		AnimLabel.text = "No animation data on this model (controls diabled)";
			 		
			 		CollView.addEventListener(ColladaViewer.ANIM_LOADED, setTimeLine);
			 		CollView.addEventListener(ColladaViewer.FRAME_CHANGE, updateAniSlider);
			 		CollView.addEventListener(ColladaViewer.ANIM_CHECK, animationCheck); //checking if there is animation
			 	
			 		_modelAnimated = false;
		
					CollView.deInit3D();
					
					//setting directories
					CollView.modelDir = LMText.text;
					CollView.textureDir = LTText.text;
					//keep same colour choices as set with previous models
					CollView.newModCol = ModelColour.selectedColor;
					CollView.newWFCol = WireFrameColour.selectedColor;
					
					CollView.init3d();
					
					reloadDaeData(); //if secondary window open reload dae data
					
					if (CollView.autoTexture) {
						wireOnOff.enabled = false;
						colourOnOff.enabled = false;
						WireFrameColour.enabled = false;
						ModelColour.enabled = false;
						ModelColourText.alpha = 0.2;
						WFColourText.alpha = 0.2;
					} else {
						wireOnOff.enabled = true;
						colourOnOff.enabled = true;
						WireFrameColour.enabled = true;
						ModelColour.enabled = true;
						ModelColourText.alpha = 1;
						WFColourText.alpha = 1;
					}
	 			}
	 	} else {
	 		if (!_modelSelected) {
	 			trace("model not selected");
	 		}
	 	}
		
		wireOnOff.selected = !CollView.invisWire;
		colourOnOff.selected = !CollView.invisColor;
		
		//resetting all sliders moved
		resetModel();
	 }
	
	protected function makeHitBox():void {
		this.setChildIndex(EmptyBox, numChildren -1); //make sure on top
		
		//make sure it will receive mouse inputs
		EmptyBox.enabled = true;
		EmptyBox.mouseEnabled = true;
		
		//drawing rectangle to put inside
		 var __box:Sprite = new Sprite();
		__box.graphics.beginFill(0);
		__box.graphics.drawRect(0,0, CollView.width, CollView.height);
		__box.graphics.endFill();
		EmptyBox.addChild(__box); 
		
		//adding event listeners
		this.addEventListener(MouseEvent.MOUSE_MOVE, interactiveMove);
		EmptyBox.addEventListener(MouseEvent.MOUSE_OVER, mouseOverBox);
		EmptyBox.addEventListener(MouseEvent.MOUSE_WHEEL, mouseZoom);
		EmptyBox.addEventListener(MouseEvent.MIDDLE_MOUSE_DOWN, mmDown);
	}
	
	protected function moveBG():void {
		this.setChildIndex(BG, 0);
		BG.addEventListener(MouseEvent.MOUSE_DOWN, dragWindow);
		Logo.addEventListener(MouseEvent.MOUSE_DOWN, dragWindow);
	}
	
	//opens a new window with edittable, for current model DAE XML open
	protected function openXMLWin():void {
		
		if (!_secondaryWinOpen) {
			createSecondaryWin();
	        _xmlWin.open();
	        _secondaryWinOpen = true;
	        _xmlWin.addEventListener(XMLWin.CREATION_DONE, initLoadData);
  		} else {
  			if (_xmlWin != null) {
				_xmlWin.close();
				_secondaryWinOpen = false;
			}
  		}
	}

	protected function pauseAnimation():void {
		CollView.pauseAnim();
		
		Play.label = "play";
		_playButton = true;
	}

	protected function playPauseAnimation():void {
		if (_playButton) {
			CollView.playAnim();
			Play.label = "pause";
		} else {
			CollView.pauseAnim();
			Play.label = "play";
		}
		
		_playButton = !_playButton;
	}

	protected function readIOErrorHandler():void {
		_daeDataStream.removeEventListener(IOErrorEvent.IO_ERROR, readIOErrorHandler);
		
		_daeDataStream.close();
		var str:String = "There was a reading error. Please check filePath or try again :)";
		_xmlWin.daeData.text = str;
	}
	
	protected function reloadDaeData():void {
		if (_xmlWin != null) {
			loadDaeData();
		}
	}
	
	protected function resetApplication():void {
		CollView.removeEventListener(ColladaViewer.ANIM_LOADED, setTimeLine);
		CollView.removeEventListener(ColladaViewer.FRAME_CHANGE, updateAniSlider);
		CollView.removeEventListener(ColladaViewer.ANIM_CHECK, animationCheck); //checking if there is animation
		_modelAnimated = false;
		
		resetCam();
		resetModel();
		CollView.deInit3D();
		
		LTText.text = "";
		LMText.text= "";
		
		//close window
		if (_xmlWin != null) {
			_xmlWin.close();
			_secondaryWinOpen = false;
		}
		
		PreloadAnim.visible=false; //then hide preloader
	 	PreloadText.visible=false;
	 	
	 	resetStats();
	}
	
	protected function resetCam():void {
	 	CollView.resetCamera();
	 }
	 
 	 //if errors in loading then must reset everything
	 protected function resetLoad(e:Event):void {
		resetApplication(); //then reset entire app (crash)
	} 
	
	protected function resetModel():void {
	 	XRotSlide.value = 0;
	 	deltaRotX();
	 	YRotSlide.value = 0;
	 	deltaRotY();
	 	ScaleSlide.value = 1;
	 	ScaleSlideCoarse.value = 1;
	 	
	 	CollView.stopAnim();
	 	deltaScale();
	 }
	 
	 protected function resetStats():void { 	
		Triangles.text = "0";
		Vertices.text = "0";
		Num3DObjects.text = "0";
		RotationX.text = "0";
		RotationY.text = "0";
		Scale.text = "0";
		ScaleDiff.text = "0";
	}
	
	//Helper function to round a number to a decimal place (from Fuel Wiki)
	protected function round(_number:Number, _decimal:int):Number {
		var offset:int = Math.pow(10, _decimal);
		_number *= offset;
		_number = Math.round(_number);
		_number /= offset;
				
		return _number;
	}
	
	protected function stopAnimation():void {
		CollView.stopAnim();
		
		Play.label = "play";
		_playButton = true;
	}
	
	protected function targetVisSwitch():void {
	 	CollView.invisTarget = !CollView.invisTarget;
	 }

	 protected function wireVisSwitch():void {
	 	CollView.invisWire = !CollView.invisWire; //swicth wireframe on or off
	 }
	 
	 /****************************************************************/
	 /*********************** end methods ****************************/
	 /****************************************************************/